#BEGIN COPYRIGHT
#************************************************************************************
# IBM Confidential
# OCO Source Materials
# 5639-D57,5630-A36,5630-A37,5724-D18
# @ Copyright IBM Corporation 2010.
# The source code for this program is not published or otherwise
# divested of its trade secrets, irrespective of what has been
# deposited with the U.S. Copyright Office.
#*************************************************************************
#END COPYRIGHT

import sys
from com.ibm.j2ca.migration.wpsruntime.base import WPSMigrationUtil

wpsRootPath=WPSMigrationUtil.getSystemProperty("was.install.root")
fileSeparator=WPSMigrationUtil.getFileSeparator()
scriptsPath=wpsRootPath+fileSeparator+"util"+fileSeparator+"adapterMigration"+fileSeparator
sys.path.append(scriptsPath)

import printHelper as PrintHelper

#
#####################################################################
## NOTE: This code is PRELIMINARY, it requires MANUAL VERIFICATION ##
##                    ***********              ******************* ##
#####################################################################
#

import sys
def wsadminToList(inStr):
        outList=[]
        #print "******inStr = " + inStr
        if (len(inStr)>0 and inStr[0]=='[' and inStr[-1]==']'):
                tmpList = inStr[1:-1].split() #splits space-separated lists,
        else:
                tmpList = inStr.split("\n")   #splits for Windows or Linux
        for item in tmpList:
                item = item.rstrip();         #removes any Windows "\r"
                #print "******item = " + item
                if (len(item)>0):
                        outList.append(item)
        return outList
#endDef

def wsadminToList1(inStr):
	outList=[]
	#print "******inStr1 = " + inStr
	if (len(inStr)>0 and inStr[0]=='[' and inStr[-1]==']'):
		tmpList = inStr[1:-1].split(')')
	else:
		tmpList = inStr.split("\n")   #splits for Windows or Linux
	for item in tmpList:
		item = item.rstrip();         #removes any Windows "\r"
		item = item + ')'
		#print "******item = " + item
		if (len(item)>0):
			outList.append(item)
	return outList
#endDef


errorCode = ""
errorInfo = ""


######################## Find Embedded Deployed Resource Adapters and Applications#############################
def findEmbeddedRAApps (  ):
	PrintHelper.printInfo("Finding embedded adapter and applications... ")
	
	#--------------------------------------------------------------
	# set up globals
	#--------------------------------------------------------------
	global AdminConfig
	
	#--------------------------------------------------------------
	# initiate the return list value 'raEmbeddedApplications'
	#--------------------------------------------------------------
	raEmbeddedApplications = []
	
	#--------------------------------------------------------------
	# for all deployments
	#--------------------------------------------------------------
	#set deployments [$AdminConfig getid /Deployment:/]
	deployments = AdminConfig.list("Deployment")
	deploymentsArr = wsadminToList(deployments)
	#print "deployments = " + deployments
	for deployment in deploymentsArr:
		#?PROBLEM? (jacl 24) previous FOREACH_ITEM_IN_LIST may need variable.split("xx")
		#--------------------------------------------------------------
		# initiate local variable 
		#--------------------------------------------------------------
		connectorModules = []
		hasRA = 0
		#print "deployment = " + deployment
		appName = deployment.split('(')[0]
 		#print "-------------appname = "+ appName
 		#?PROBLEM? (jacl 31) previous LINDEX may need variable.split("xx")
		depObject = AdminConfig.showAttribute(deployment, "deployedObject" )
		#print "depObject = " + depObject
		modules = AdminConfig.showAttribute(depObject, "modules" )
		#print "++++++++++++modules = " + modules
		modulesArr = wsadminToList1(modules)

		#?PROBLEM? (jacl 33) previous LINDEX may need variable.split("xx")
		#set modules [$AdminConfig showAttribute $depObject modules]
		#set url [$AdminConfig showAttribute $depObject binariesURL]
		#--------------------------------------------------------------
		# for all modules
		#--------------------------------------------------------------	
		for module in modulesArr:
			ra=''
			try:
				_excp_ = 0
				ra = AdminConfig.showAttribute(module, "resourceAdapter" )
				#print "0000000000000000000"
				_excp_ = 0 #reset (in case of nested exceptions)
			except:
				_type_, _value_, _tbck_ = sys.exc_info()
				ra = str(_value_)
				_excp_ = 1
			#endTry 
			success = _excp_
			if (success != 0):
				continue 
			#endIf 
			#--------------------------------------------------------------
			# it is ConnectorModule
			#--------------------------------------------------------------
			connectorModules = []
			hasRA = 0
			#print "RA appName : "+appName
			raName = AdminConfig.showAttribute(ra, "name" )
			#print "raName : "+raName
			raDeploymentDes = AdminConfig.showAttribute(ra, "deploymentDescriptor" )
			raVersion = AdminConfig.showAttribute(raDeploymentDes, "version" )
			#print "raVersion : "+raVersion
			raUri = AdminConfig.showAttribute(module, "uri" )
			#print "raUri : "+raUri
			showalldeployment = AdminConfig.showall(deployment)
			connectorModules.append([raName, raVersion, raUri, ra])
			#print "connectorModules = "+connectorModules

			hasRA = hasRA+1
		#endFor 
		#puts "-------connectorModules $connectorModules"
		#--------------------------------------------------------------
		# if the application has ConnectorModule
		#--------------------------------------------------------------
		if (hasRA > 0):
			raEmbeddedApplications.append([appName, connectorModules])
		#endIf
	#endFor 
	#PrintHelper.printInfo("*** *** *** *** Exit the procedure 'findEmbeddedRAApps' *** *** *** *** ")
	return raEmbeddedApplications
#endDef 