#BEGIN COPYRIGHT
#************************************************************************************
# IBM Confidential
# OCO Source Materials
# 5639-D57,5630-A36,5630-A37,5724-D18
# @ Copyright IBM Corporation 2010.
# The source code for this program is not published or otherwise
# divested of its trade secrets, irrespective of what has been
# deposited with the U.S. Copyright Office.
#*************************************************************************
#END COPYRIGHT

import sys
from com.ibm.j2ca.migration.wpsruntime.base import WPSMigrationUtil

wpsRootPath=WPSMigrationUtil.getSystemProperty("was.install.root")
fileSeparator=WPSMigrationUtil.getFileSeparator()
scriptsPath=wpsRootPath+fileSeparator+"util"+fileSeparator+"adapterMigration"+fileSeparator
sys.path.append(scriptsPath)

import sys
import printHelper as PrintHelper
#
###################################################################################
## This code is for find applications with standalone deployed WebSphere Adapter ##
###################################################################################
#

######################## Utils #############################

#def listSearch(lst, target):
#        if(lst.count(target)<=0): return -1
#        return lst.index(target)
def wsadminToList(inStr):
        outList=[]
        if (len(inStr)>0 and inStr[0]=='[' and inStr[-1]==']'):
                tmpList = inStr[1:-1].split() #splits space-separated lists,
        else:
                tmpList = inStr.split("\n")   #splits for Windows or Linux
        for item in tmpList:
                item = item.rstrip();         #removes any Windows "\r"
                if (len(item)>0):
                        outList.append(item)
        return outList
#endDef

def wsadminToList1(inStr):
        outList=[]
        if (len(inStr)>0 and inStr[0]=='[' and inStr[-1]==']'):
                tmpList = inStr[1:-1].split(None, 1) #splits space-separated lists,
        else:
                tmpList = inStr.split("\n")   #splits for Windows or Linux
        for item in tmpList:
                item = item.rstrip();         #removes any Windows "\r"
                if (len(item)>0):
                        outList.append(item)
        return outList
#endDef

def stripPrefix_Suffix(inStr, fix):
	fixLen = len(fix)
	inStrLen = len(inStr)
	#print "inStr="+inStr + "  fix="+fix
	if (fixLen>0 and inStrLen>0 and inStr[0:fixLen]==fix and inStr[inStrLen-fixLen:inStrLen]==fix):
		str = inStr[fixLen:inStrLen-fixLen]
		#print "str="+str
		return str
	return ""
#endDef

def findClusterApps (  ):
	PrintHelper.printInfo("Finding stand alone WebSphere Adapter applications on clusters... ")

	#--------------------------------------------------------------
	# initiate the return list value 'clusterApps'
	#--------------------------------------------------------------
	clusterApps = []
	
	#--------------------------------------------------------------
	# Find all clusters
	#--------------------------------------------------------------
	PrintHelper.printInfo("Finding Clusters...")
	clusterlist = AdminConfig.list("ServerCluster" )
	clusterArr = wsadminToList(clusterlist)
	for cluster in clusterArr:
		PrintHelper.printInfo("cluster = "+cluster)
		clusterNameStr = AdminConfig.show(cluster, "name")
		clusterNameList = wsadminToList(clusterNameStr)                
		clusterName = clusterNameList[1]
		PrintHelper.printInfo("clusterName = " + clusterName)
		
		#--------------------------------------------------------------
		# Find Resource Adpaters on the cluster
		#--------------------------------------------------------------
		PrintHelper.printInfo("Finding the Resource Adapter on cluster = "+clusterName+"...")
		ralistStr = AdminConfig.list("J2CResourceAdapter", cluster )
		raList = wsadminToList(ralistStr)
		raAppsList = []
		for ra in raList:
			raNameStr = AdminConfig.show(ra, ["name"] )
			raNameList = wsadminToList1(raNameStr)
			raName = stripPrefix_Suffix(raNameList[1],"\"")
			
			#---------------------------------------------------------------
			# If it's a WebSphere Adapter, then find the applications which 
			# reference to the ConnectionFactory on the adapter
			#--------------------------------------------------------------
			isWebSphereAdapter = WPSMigrationUtil.isSupportedAdapterName(raName)
			if (isWebSphereAdapter):
				PrintHelper.printInfo("WebSphere Resource Adapter = "+raName)
				raDeploymentDes = AdminConfig.showAttribute(ra, "deploymentDescriptor" )
				raVersion = AdminConfig.showAttribute(raDeploymentDes, "version" )
				
				nodelist = AdminConfig.list("Node" )
				nodeArr = wsadminToList(nodelist)
				
				#--------------------------------------------------------------
				# Find all Connection Factory on the Resource Adapter
				#--------------------------------------------------------------    
				raCFStr = AdminConfig.list("J2CConnectionFactory", ra )
				raCFList = wsadminToList(raCFStr)
				raCFAppsList = []
				for cf in raCFList:
					PrintHelper.printInfo("cf = "+cf)
					cfJNDIName = AdminConfig.showAttribute(cf, "jndiName" )
					PrintHelper.printInfo("cfJNDIName : "+cfJNDIName)
					#--------------------------------------------------------------
					# Find the Applications reference to the Connection Factory on  the Resource Adapter. 
					#--------------------------------------------------------------
					PrintHelper.printInfo("Searching for applications refer to CF = "+cfJNDIName+"...")
					raStandaloneAppsList_CF = []
					for node in nodeArr:
						appsOnNodeStr_CF = AdminApp.searchJNDIReferences(node, ["-JNDIName", cfJNDIName] )
						appsOnNodeList_CF = wsadminToList(appsOnNodeStr_CF)
						for app in appsOnNodeList_CF:
							if (app not in raStandaloneAppsList_CF):
								raStandaloneAppsList_CF.append(app)
					#end for nodes
					raCFAppsList.append([cfJNDIName, raStandaloneAppsList_CF])
				#endFor 
				PrintHelper.printInfo("raCFAppsList :")
				PrintHelper.printInfo(raCFAppsList)

				#--------------------------------------------------------------
				# Find all Activation Spec on the Resource Adapter
				#-------------------------------------------------------------- 
				raASStr = AdminConfig.list("J2CActivationSpec", ra )
				raASList = wsadminToList(raASStr)
				raASAppsList = []
				for aspec in raASList :
					PrintHelper.printInfo("aspec = "+aspec)
					asJNDIName = AdminConfig.showAttribute(aspec, "jndiName")
					PrintHelper.printInfo("asJNDIName = "+asJNDIName)
					#--------------------------------------------------------------
					# Find the Applications reference to the ActivationSpec on the Resource Adapter. 
					#--------------------------------------------------------------
					PrintHelper.printInfo("Searching for applications refer to AS = "+asJNDIName+"...")
					raStandaloneAppsList_AS = []
					for node in nodeArr:
						appsOnNodeStr_AS = AdminApp.searchJNDIReferences(node, ["-JNDIName", asJNDIName] )
						appsOnNodeList_AS = wsadminToList(appsOnNodeStr_AS)
						for app in appsOnNodeList_AS:
							if (app not in raStandaloneAppsList_AS):
								raStandaloneAppsList_AS.append(app)
					#end for nodes
					raASAppsList.append([asJNDIName, raStandaloneAppsList_AS])
				#endfor
				PrintHelper.printInfo("raASAppsList :")
				PrintHelper.printInfo(raASAppsList)

				raAppsList.append([ra, raName, raVersion, raCFAppsList, raASAppsList])
			#endIf 
		#endFor RA
		clusterApps.append([cluster, raAppsList])
	#endFor cluster

	PrintHelper.printInfo("End of finding Clusters...")
	return clusterApps
#endDef 

def findClusterRAJNDIs():
	#--------------------------------------------------------------
	# initiate the return list value 'clusterRAJNDIs'
	#--------------------------------------------------------------
	clusterRAJNDIs = []
	#--------------------------------------------------------------
	# Find all clusters
	#--------------------------------------------------------------
	clusterlist = AdminConfig.list("ServerCluster" )
	clusterArr = wsadminToList(clusterlist)
	for cluster in clusterArr:
		#--------------------------------------------------------------
		# Find Resource Adpaters on the cluster
		#--------------------------------------------------------------
		ralistStr = AdminConfig.list("J2CResourceAdapter", cluster )
		raList = wsadminToList(ralistStr)
		raJNDIsList = []
		for ra in raList:
			raNameStr = AdminConfig.show(ra, ["name"] )
			raNameList = wsadminToList1(raNameStr)
			raName = stripPrefix_Suffix(raNameList[1],"\"")
			#---------------------------------------------------------------
			# If it's a WebSphere Adapter, then find the CF/AS JNDIs
			#--------------------------------------------------------------
			isWebSphereAdapter = WPSMigrationUtil.isSupportedAdapterName(raName)
			if (isWebSphereAdapter):
				raDeploymentDes = AdminConfig.showAttribute(ra, "deploymentDescriptor" )
				raVersion = AdminConfig.showAttribute(raDeploymentDes, "version" )
				#--------------------------------------------------------------
				# Find all Connection Factory on the Resource Adapter
				#--------------------------------------------------------------    
				raCFStr = AdminConfig.list("J2CConnectionFactory", ra )
				raCFList = wsadminToList(raCFStr)
				#--------------------------------------------------------------
				# Find all Activation Spec on the Resource Adapter
				#-------------------------------------------------------------- 
				raASStr = AdminConfig.list("J2CActivationSpec", ra )
				raASList = wsadminToList(raASStr)

				raJNDIsList.append([ra, raName, raVersion, raCFList, raASList])
			#endIf 
		#endFor 
		clusterRAJNDIs.append([cluster, raJNDIsList])
	#endFor 
	return clusterRAJNDIs
#endDef 

def findStandaloneRAApps(nodeName):
	PrintHelper.printInfo("Finding stand alone adapter and applications on node="+nodeName+"... ")

	#--------------------------------------------------------------
	# initiate the return list value 'raStandaloneApplications'
	#--------------------------------------------------------------
	raStandaloneApplications = []
	#--------------------------------------------------------------
	# Find all the MCF/AS JNDIs that defined on cluster adapter
	#--------------------------------------------------------------
	clusterRAJNDIs = findClusterRAJNDIs()

	#--------------------------------------------------------------
	# Find all nodes
	#--------------------------------------------------------------
	PrintHelper.printInfo("Finding Nodes...")
	nodelist = AdminConfig.list("Node" )
	nodeArr = wsadminToList(nodelist)
	for node in nodeArr:
		nodeNameStr = AdminConfig.show(node, "name")
		nodeNameList = wsadminToList(nodeNameStr)                
		node_N = nodeNameList[1]
		#nodeName = nodeNameList[1]
		if (node_N != nodeName):
			continue;

		PrintHelper.printInfo("node = "+node)
		PrintHelper.printInfo("nodeName = " + nodeName)
		
		#--------------------------------------------------------------
		# Find Resource Adpaters on the Node
		#--------------------------------------------------------------
		PrintHelper.printInfo("Finding the Resource Adapter on node = "+nodeName+"...")
		ralistStr = AdminConfig.list("J2CResourceAdapter", node )
		raList = wsadminToList(ralistStr)
		raApplicationsList = []
		for ra in raList:
			raNameStr = AdminConfig.show(ra, ["name"] )
			raNameList = wsadminToList1(raNameStr)
			raName = stripPrefix_Suffix(raNameList[1],"\"")
			
			#---------------------------------------------------------------
			# If it's a WebSphere Adapter, then find the applications which reference to the ConnectionFactory or ActivationSpec on the adapter
			#--------------------------------------------------------------
			isWebSphereAdapter = WPSMigrationUtil.isSupportedAdapterName(raName)
			print '+++++++++raName:'+raName
			print isWebSphereAdapter
			if (isWebSphereAdapter):
				PrintHelper.printInfo("WebSphere Resource Adapter = "+raName)
				raDeploymentDes = AdminConfig.showAttribute(ra, "deploymentDescriptor" )
				raVersion = AdminConfig.showAttribute(raDeploymentDes, "version" )
				
				#--------------------------------------------------------------
				# Find all Connection Factory on the Resource Adapter
				#--------------------------------------------------------------    
				raCFStr = AdminConfig.list("J2CConnectionFactory", ra )
				raCFList = wsadminToList(raCFStr)
				#--------------------------------------------------------------
				# Find all Activation Spec on the Resource Adapter
				#-------------------------------------------------------------- 
				raASStr = AdminConfig.list("J2CActivationSpec", ra )
				raASList = wsadminToList(raASStr)
				
				#--------------------------------------------------------------
				# Will also check the applications that reference to the adapter MCF/AS defined on clusters
				#--------------------------------------------------------------    
				for oneCluster in clusterRAJNDIs:
					cluster = oneCluster[0]
					clusterRA_JNDIsList = oneCluster[1]
					for oneClusterRA in clusterRA_JNDIsList:
						clusterRA = oneClusterRA[0]
						clusterRAName = oneClusterRA[1]
						clusterRAVersion = oneClusterRA[2]
						#--------------------------------------------------------------
						# If the adapter defined on the cluster is the same with the current adapter defined on current node, we will consider 
						# the MCF/AS defined on the cluster adapter as well, to check if there are applications refer to them later
						#--------------------------------------------------------------
						if ( clusterRAName==raName ):
							clusterRA_CFJNDIs = oneClusterRA[3]
							for oneRA_CFJNDI in clusterRA_CFJNDIs:
								raCFList.append(oneRA_CFJNDI)
							
							clusterRA_ASJNDIs = oneClusterRA[4]
							for oneRA_ASJNDI in clusterRA_ASJNDIs:
								raASList.append(oneRA_ASJNDI)
						#end if
					#end for -- RA
				#endFor -- cluster
				
				#--------------------------------------------------------------
				# For all Connection Factory on the adapter
				#-------------------------------------------------------------- 
				raCFAppsList = []
				for cf in raCFList:
					PrintHelper.printInfo("cf = "+cf)
					cfJNDIName = AdminConfig.showAttribute(cf, "jndiName" )
					PrintHelper.printInfo("cfJNDIName : "+cfJNDIName)
					#--------------------------------------------------------------
					# Find the Applications reference to the Connection Factory on  the Resource Adapter. 
					#--------------------------------------------------------------
					PrintHelper.printInfo("Searching for applications refer to CF = "+cfJNDIName+"...")
					raStandaloneAppsStr_CF = AdminApp.searchJNDIReferences(node, ["-JNDIName", cfJNDIName] )
					raStandaloneAppsList_CF = wsadminToList(raStandaloneAppsStr_CF)
					PrintHelper.printInfo("raStandaloneAppsList_CF :")
					PrintHelper.printInfo(raStandaloneAppsList_CF)
					#--------------------------------------------------------------------------------
					# One Connection Factory may be referenced by many applications by the cfJNDIName
					#--------------------------------------------------------------------------------
					raCFAppsList.append([cfJNDIName, raStandaloneAppsList_CF])
				#endFor 
				
				#--------------------------------------------------------------
				# For all Activation Spec on the adapter
				#-------------------------------------------------------------- 
				raASAppsList = []
				for aspec in raASList :
					PrintHelper.printInfo("aspec = "+aspec)
					asJNDIName = AdminConfig.showAttribute(aspec, "jndiName")
					PrintHelper.printInfo("asJNDIName = "+asJNDIName)
					#--------------------------------------------------------------
					# Find the Applications reference to the ActivationSpec on the Resource Adapter. 
					#--------------------------------------------------------------
					PrintHelper.printInfo("Searching for applications refer to AS = "+asJNDIName+"...")
					raStandaloneAppsStr_AS = AdminApp.searchJNDIReferences(node, ["-JNDIName", asJNDIName] )
					raStandaloneAppsList_AS = wsadminToList(raStandaloneAppsStr_AS)
					PrintHelper.printInfo("raStandaloneAppsList_AS :")
					PrintHelper.printInfo(raStandaloneAppsList_AS)
					#--------------------------------------------------------------------------------
					# One ActivationSpec may be referenced by many applications by the asJNDIName
					#--------------------------------------------------------------------------------
					raASAppsList.append([asJNDIName, raStandaloneAppsList_AS])
				#endfor

				raApplicationsList.append([ra, raName, raVersion, raCFAppsList, raASAppsList])
			#endIf 
		#endFor 
		raStandaloneApplications.append([node, raApplicationsList])
		break;
	#endFor 
	#PrintHelper.printInfo("Standalone Applications found on node="+nodeName+":")
	PrintHelper.printInfo(raStandaloneApplications)
	PrintHelper.printInfo('\n')
	return raStandaloneApplications
#endDef