#BEGIN COPYRIGHT
#************************************************************************************
# IBM Confidential
# OCO Source Materials
# 5639-D57,5630-A36,5630-A37,5724-D18
# @ Copyright IBM Corporation 2010.
# The source code for this program is not published or otherwise
# divested of its trade secrets, irrespective of what has been
# deposited with the U.S. Copyright Office.
#*************************************************************************
#END COPYRIGHT

import sys
from com.ibm.j2ca.migration.wpsruntime.base import WPSMigrationUtil

wpsRootPath=WPSMigrationUtil.getSystemProperty("was.install.root")
fileSeparator=WPSMigrationUtil.getFileSeparator()
scriptsPath=wpsRootPath+fileSeparator+"util"+fileSeparator+"adapterMigration"+fileSeparator
sys.path.append(scriptsPath)

import printHelper as PrintHelper

def updateEmbededRAR(exportEarFile, appName, adapterName, adapterVersion, RAURI, raID):
	# Get the working temp dir
	migrationWorkDir = WPSMigrationUtil.getMigrationWorkDir()

	PrintHelper.printInfo("Updating embedded adapter for app="+appName+" adapter="+adapterName+" ver="+adapterVersion)
	oldRAR = WPSMigrationUtil.getRARInsideEar(exportEarFile, migrationWorkDir)
	PrintHelper.printInfo("oldRAR="+oldRAR)
	updatedRAR = WPSMigrationUtil.getUpdatedAdapterRARLoc(oldRAR, adapterName, migrationWorkDir)
	PrintHelper.printInfo("generated new RAR file "+updatedRAR+ " for embedded adapter "+ adapterName + " for app="+appName)

	#updateCmd = "[-operation addupdate -contents " + updatedZIPPath + " -contenturi " + RAURI + "]";
	#AdminApp.update(appName, 'partialapp', updateCmd)
	updateCmd = "[-operation update -contents "+ updatedRAR + " -contenturi "+ RAURI + "]"
	AdminApp.update(appName, "file", updateCmd)

	name=AdminConfig.showAttribute(raID,"name")
	#raname=name.split(".")[1]
	raname=WPSMigrationUtil.getPureAdapterName(adapterName)
	newadaptername=WPSMigrationUtil.getAdapterNewName(adapterName)
	
	if(raname != newadaptername):
		AdminConfig.resetAttributes(raID,[["name",name.replace(raname,newadaptername)]])

	#PrintHelper.printInfo("---update command="+updateCmd)
	AdminConfig.save()

	# Delete the Work Dir
	if ( WPSMigrationUtil.toRemoveTempFiles() ):
		WPSMigrationUtil.deleteFile(migrationWorkDir)

	PrintHelper.printInfo("----Successfully update the embeded adapter for app="+ appName)
#end def updateEmbeddedRAR