import sys
from com.ibm.j2ca.migration.wpsruntime.base import WPSMigrationUtil
from java.lang import System

wpsRootPath=WPSMigrationUtil.getSystemProperty("was.install.root")
# Define the script path
fileSeparator=WPSMigrationUtil.getFileSeparator()
scriptsPath=wpsRootPath+fileSeparator+"util"+fileSeparator+"adapterMigration"+fileSeparator
sys.path.append(scriptsPath)

import printHelper as PrintHelper

#import findEmbeddedRAApplications as FindEmbededRAApps
import findStandaloneRAApplications as FindStandAloneRAApps
#import updateEmbededRAR as UpdateEmbededRAR
import updateStandaloneRAR as UpdateStandAloneRAR
import migrateApp as MigrateApp
#import migrateApp as MigrateApp

def getNodeType():
	nodeType = WPSMigrationUtil.getSystemProperty("bpm.upgrade.node.type")
	if (nodeType==""):
		nodelist = AdminConfig.list('Node')
		nodeArr = FindStandAloneRAApps.wsadminToList(nodelist)
		nodeNum = len(nodeArr)
		if ( nodeNum > 1 ):
			nodeType = "dmgr"
		else:
			nodeType = "node"
	
	return nodeType

PrintHelper.printInfo("+++++++++++++starting to load updateStandaloneAdapter.py")

WPSMigrationUtil.setWPSHome(wpsRootPath)
newRARFolder=wpsRootPath+fileSeparator+"installableApps"+fileSeparator
WPSMigrationUtil.setNewRARDir(newRARFolder)
tempFolder=WPSMigrationUtil.getSystemProperty("bpm.upgrade.backup.dir")
WPSMigrationUtil.setTempDir(tempFolder)

# Retrieve the value of WPS HOME from system environment property
#wpsRootPath=WPSMigrationUtil.getSystemProperty("was.install.root")
nodeType = getNodeType()

if ( nodeType=="dmgr" ):
	PrintHelper.printInfo('Skip DMGR.')
else:
	#try:
	configurationFile = scriptsPath+"adapterMigrationInfo.xml"
	PrintHelper.printInfo("----Loading configuration info from "+configurationFile)
	WPSMigrationUtil.getAdapterMigrationInfo(configurationFile)
	#tempFolder = WPSMigrationUtil.getTempDir();

	nodeName = MigrateApp.getNodename();
	PrintHelper.printInfo('starting to find standalone RAR on node=')
	PrintHelper.printInfo(nodeName)
	raStandaloneRAAppList = FindStandAloneRAApps.findStandaloneRAApps(nodeName)
	PrintHelper.printInfo('after find standalone RAR')
	for oneNode in raStandaloneRAAppList:
		toMigrateApps = []
		node = oneNode[0]
		PrintHelper.printInfo('------------find nodes:')
		PrintHelper.printInfo(node)
		adapters = oneNode[1]
		PrintHelper.printInfo('-----------find adapters:')
		PrintHelper.printInfo(adapters)
		for oneAdapter in adapters:
			PrintHelper.printInfo('++++++++adapter:')
			PrintHelper.printInfo(oneAdapter)
			ra = oneAdapter[0]
			raN = oneAdapter[1]
			raV = oneAdapter[2]
			PrintHelper.printInfo(ra)
			if ( WPSMigrationUtil.isSupportedArtifact(raN, raV)):
				PrintHelper.printInfo('This is a supported adapter....')
				UpdateStandAloneRAR.updateStandAloneRAR(nodeName, raN)
	#except:
	#	PrintHelper.printInfo('Failed with error')
	#	PrintHelper.printInfo( sys.exc_type)
	#	PrintHelper.printInfo( sys.exc_value)