#BEGIN COPYRIGHT
#************************************************************************************
# IBM Confidential
# OCO Source Materials
# 5639-D57,5630-A36,5630-A37,5724-D18
# @ Copyright IBM Corporation 2010.
# The source code for this program is not published or otherwise
# divested of its trade secrets, irrespective of what has been
# deposited with the U.S. Copyright Office.
#*************************************************************************
#END COPYRIGHT
# script to update stanalone RAR, includes save connection factory, save activation spec, uninstall RAR , install RAR, create connection factory, create activation spec
# script take 2 inputs.. adapter rarname, new RAR path

#For Example...
#C:\WID62\runtimes\bi_v62\bin>wsadmin -lang jython -f 
#updateStandaloneRAR.py "IBM WebSphere Adapter for FTP" "C:/temp/CWYFT_FTPFile.rar" 

import sys
from com.ibm.j2ca.migration.wpsruntime.base import WPSMigrationUtil

wpsRootPath=WPSMigrationUtil.getSystemProperty("was.install.root")
fileSeparator=WPSMigrationUtil.getFileSeparator()
scriptsPath=wpsRootPath+fileSeparator+"util"+fileSeparator+"adapterMigration"+fileSeparator
sys.path.append(scriptsPath)

import printHelper as PrintHelper
import migrateApp as migrateApp
from java.util import Properties
from java.util import Date
from java.lang import System

lineSeparator = System.getProperty("line.separator")
cfProperties = ['authDataAlias','authMechanismPreference','category','description','diagnoseConnectionUsage','jndiName','logMissingTransactionContext','manageCachedHandles','name','preTestConfig','providerType','xaRecoveryAuthAlias']
asProperties = ['authenticationAlias','description','jndiName','name']
raProperties = ['classpath']

def setProperties(object,propName,propValue,type) :
	propslist = AdminConfig.list("J2EEResourceProperty",object)
	propsarr = propslist.split(lineSeparator)
	for p in propsarr:
		if (propName.lower() == AdminConfig.showAttribute(p,"name").lower()):
			AdminConfig.modify(p,[["value",propValue]])
            #print " value after replace : "+ AdminConfig.showAttribute(p,"value")
			break
	if (type == 'connectionfactory'):
		for ps in cfProperties:
			if (propName.lower() == ps.lower()) :
				AdminConfig.modify(object,[[propName,propValue]])
				#AdminTask.setResourceProperty(cf,'[-propertyName '+propName + ' -propertyValue ' +propValue +']')
				break
	if (type == 'activationspec'):
		for ps in asProperties:
			if (propName.lower() == ps.lower()) :
				AdminConfig.modify(object,[[propName,propValue]])
				#AdminTask.setResourceProperty(cf,'[-propertyName '+propName + ' -propertyValue ' +propValue +']')
				break
#end def setProperties(object,propName,propValue,type)

def setPropertiesToFile(filename,properties):
	from java.io import FileOutputStream
	from java.io import File
	from java.util import Properties

	os = FileOutputStream(File(filename))

	properties.save(os,"")
	PrintHelper.printInfo( "properties file : " + filename + " saved succesfully.")
#end def setPropertiesToFile(filename,properties)

def getPropertiesFromFile(filename):
	from java.io import FileInputStream
	from java.io import File
	from java.util import Properties

	ins = FileInputStream(File(filename))

	p = Properties()
	p.load(ins)
#	v = p.getProperty("key")
	return p
#end def getPropertiesFromFile(filename)

def createConnectionFactory(cellname,nodename,rarname,property):
	#j2cra = AdminConfig.getid('/J2CResourceAdapter:'+rarname+'/')
	j2cra = AdminConfig.getid('/Cell:'+cellname+'/Node:'+nodename+'/J2CResourceAdapter:\"'+rarname+'\"/')

	try:
		cf = AdminTask.createJ2CConnectionFactory(j2cra,'[-name '+ '\''+ property.getProperty("name") + '\''+' -jndiName '+ '\''+ property.getProperty("jndiName")+ '\'' +']')
		for propname in property.propertyNames():
				if(property.getProperty(propname) != None):
					setProperties(cf,propname,property.getProperty(propname),'connectionfactory')
		#		if(property.getProperty("description") != None):
#			AdminTask.setResourceProperty(newcf,['-propertyName', 'description', '-propertyValue', 'description'])
				#AdminConfig.modify(cf,[[propname,property.getProperty(propname)]])
				#AdminTask.setResourceProperty(cf,['-propertyName', propname, '-propertyValue', property.getProperty(propname)])
	except:
		PrintHelper.printInfo("Create connection factory failed. root cause: ")
		PrintHelper.printInfo(sys.exc_type)
		PrintHelper.printInfo(sys.exc_value)
	else:
		AdminConfig.save()
		PrintHelper.printInfo( "successfully created connection factory: " + property.getProperty("name"))

#end def createConnectionFactory(rarname,property)

def createActivationSpec(cellname,nodename,rarname,property,dir):
	#j2cra = AdminConfig.getid('/J2CResourceAdapter:'+rarname+'/')
	j2cra = AdminConfig.getid('/Cell:'+cellname+'/Node:'+nodename+'/J2CResourceAdapter:\"'+rarname+'\"/')
	try:
		if(rarname.find('SAP') != -1):
			newrarlocation = WPSMigrationUtil.getNewAdapterRARLoc(rarname)
			messageListenerType = WPSMigrationUtil.getMessageListenerType(newrarlocation, dir, property.getProperty("activationspecClass"))
		else:
			messageListenerType = property.getProperty("messageListenerType")
		aspec = AdminTask.createJ2CActivationSpec(j2cra, '[-name '+ '\''+ property.getProperty("name")+ '\''+' -jndiName '+ '\''+property.getProperty("jndiName")+ '\''+' -messageListenerType ' + '\''+ messageListenerType + '\''+ ']')
		for propname in property.propertyNames():
			if(property.getProperty(propname) != None):
				setProperties(aspec,propname,property.getProperty(propname),'activationspec')
	except:
		PrintHelper.printInfo("Create activation spec failed. root cause:")
		PrintHelper.printInfo(sys.exc_type)
		PrintHelper.printInfo(sys.exc_value)
	else:
		AdminConfig.save()
		PrintHelper.printInfo( "successfully created activation spec: " + property.getProperty("name"))
#end def createActivationSpec(rarname,property)

def createRAproperty(cellname,nodename,rarname,property):
	#j2cra = AdminConfig.getid('/J2CResourceAdapter:'+rarname+'/')
	j2cra = AdminConfig.getid('/Cell:'+cellname+'/Node:'+nodename+'/J2CResourceAdapter:\"'+rarname+'\"/')
	for propertyName in raProperties:
		if(property.getProperty(propertyName) != None):
			AdminConfig.resetAttributes(j2cra, [[propertyName, property.getProperty(propertyName)]])
	AdminConfig.save()
			
#Return a random of 8 byte
def getRandom():
	from java.util import Random
	r = Random()
	while(1):
		x = r.nextInt(99999999)
		if(x > 9999999):
			return x.toString()
#end def getRandom()

def saveMCFprop(newra,dir,rarname):
	# read connection factory properties
	cfInterface = AdminTask.listConnectionFactoryInterfaces(newra)
	cflist = AdminTask.listJ2CConnectionFactories(newra,"[-connectionFactoryInterface " + cfInterface + "]")
	cfarr = cflist.split(lineSeparator)

	for cf in cfarr:
		if(cf == ''):
			continue
		else:
			cf_property = Properties()
			# save the property in 'cfProperties', these properties are for connection factory itself, not J2EEResourceProperty
			for prop in cfProperties:
				if (AdminConfig.showAttribute(cf, prop) != None):
					#if(prop == 'authDataAlias'):
					#	authDataAlias=AdminConfig.showAttribute(cf,prop)
					#	if(authDataAlias.find('//')!=-1):
					#		newNodeName = migrateApp.getNodename()
					#		authDataAlias=newNodeName+'//'+authDataAlias.split('//')[1]
					#	cf_property.setProperty(prop,authDataAlias)
					#else:
					cf_property.setProperty(prop,AdminConfig.showAttribute(cf, prop))
			# save the property  J2EEResourceProperty
			proplist = AdminConfig.list("J2EEResourceProperty",cf)
			proparr = proplist.split(lineSeparator)
			for propItem in proparr:
				propvalue = AdminConfig.showAttribute(propItem, 'value')
				if(propvalue != None):
					cf_property.setProperty(AdminConfig.showAttribute(propItem, 'name'),propvalue)
			# save the properties into local property file
			cfpropfile = dir + rarname+"_CF_" + getRandom() + ".properties"
			setPropertiesToFile(cfpropfile,cf_property)
#end def saveMCFprop()

def saveASprop(newra,dir,rarname):
	#read activation spec properties
	asMLTList = AdminTask.listMessageListenerTypes(newra)
	asMLTarr = asMLTList.split(lineSeparator)

	for activationspecMessageType in asMLTarr:
		if (activationspecMessageType != ''):
			activationspeclist = AdminTask.listJ2CActivationSpecs(newra,"[-messageListenerType " + activationspecMessageType +" ]")
			activationspecarr = activationspeclist.split(lineSeparator)
			for activationspec in activationspecarr:
				if (activationspec != ''):
					if(rarname.find('SAP') == -1):
						activationspecMessageType = 'com.ibm.j2ca.base.ExtendedInboundListener'
					else:
						if(rarname.find('SAP') != -1):
							newrarlocation = WPSMigrationUtil.getNewAdapterRARLoc(rarname)
							activationspecClass = WPSMigrationUtil.getActivationspecClass(newrarlocation, dir, activationspecMessageType)
					as_property = Properties()
					if(rarname.find('SAP') == -1):
						as_property.setProperty("messageListenerType",activationspecMessageType)
					else:
						as_property.setProperty("activationspecClass",activationspecClass)
					# save property in the arrar "asProperties", these properties are for activation spec itself, not J2EEResourceProperty
					for property in asProperties:
						if(AdminConfig.showAttribute(activationspec,property) != None):
							#if(property == 'authenticationAlias'):
							#	authAlias=AdminConfig.showAttribute(activationspec,property)
							#	if(authAlias.find('//')!=-1):
							#		newNodeName = migrateApp.getNodename()
							#		authAlias=newNodeName+'//'+authAlias.split('//')[1]
							#	as_property.setProperty(property,authAlias)
							#else:
							as_property.setProperty(property,AdminConfig.showAttribute(activationspec,property))
					# save property J2EEResourceProperty
					proplist = AdminConfig.list("J2EEResourceProperty",activationspec)
					proparr = proplist.split(lineSeparator)
					for propItem in proparr:
						propvalue = AdminConfig.showAttribute(propItem, 'value')
						if(propvalue != None):
							as_property.setProperty(AdminConfig.showAttribute(propItem, 'name'),propvalue)
					#save the properties into local property file
					aspropfile = dir + rarname + "_AS_" + getRandom()+".properties"
					setPropertiesToFile(aspropfile,as_property)
#end def saveASprop()

def saveClasspath(ra,dir,rarname):
	ra_property = Properties()
	for raPropertyName in raProperties:
		raPropertyValue = AdminConfig.showAttribute(ra,raPropertyName)
		ra_property.setProperty(raPropertyName,raPropertyValue)
	rapropfile = dir + rarname + "_RA_" + getRandom() + ".properties"
	setPropertiesToFile(rapropfile,ra_property)

def removeRAR(j2cra,rarname):
	#uninstall RAR
	#j2cra = AdminConfig.getid('/J2CResourceAdapter:'+rarname+'/')

	#AdminConfig.uninstallResourceAdapter(j2cra, '[-force]')
	AdminConfig.remove(j2cra)
	AdminConfig.save()
	#remove the adapter install folder
	profileFolder = System.getProperty('user.install.root')
	adapterFolder = profileFolder+fileSeparator+"installedConnectors"+fileSeparator+WPSMigrationUtil.getStandaloneAdapterFolder(rarname)
	WPSMigrationUtil.deleteFile(adapterFolder)
	
	PrintHelper.printInfo( "successfully unInstalled resource adapter: "+rarname )
#end def removeRAR
	
def installRAR(cellname,nodename,rarname,rarpath):
	rars = AdminConfig.getid('/Cell:'+cellname+'/Node:'+nodename+'/J2CResourceAdapter:\"'+rarname+'\"/')
	try:
		if (rars != ''):
			#j2cra = AdminConfig.getid('/J2CResourceAdapter:'+rarname+'/')
			PrintHelper.printInfo("remove adapter="+rarname)
			AdminConfig.remove(rars)
			AdminConfig.save();

		PrintHelper.printInfo("start to install new adapter=" +rarname +" on node=")
		PrintHelper.printInfo(nodename)
		AdminConfig.installResourceAdapter(rarpath, nodename,'[-rar.name \"'+rarname+'\" -rar.desc "WebSphere Adapter"]')
	except:
		PrintHelper.printInfo('failed to install RAR.'+rarname+' root cause:')
		PrintHelper.printInfo(sys.exc_type)
		PrintHelper.printInfo(sys.exc_value)
		PrintHelper.printInfo(sys.exc_info())
	else:
		AdminConfig.save()
		PrintHelper.printInfo( "successfully installed resource adapter: "+rarname )
#end def installRAR

def updateStandAloneRAR(nodename, rarname):
	rarpath = WPSMigrationUtil.getNewAdapterRARLoc(rarname)
	dir = WPSMigrationUtil.getMigrationWorkDir()
	
	cell = AdminConfig.list('Cell').split(lineSeparator)[0]
	cellname = cell.split('(')[0]

	#node = AdminConfig.list('Node').split(lineSeparator)[0]
	#nodename = node.split('(')[0]
	try:
		id = "/Cell:"+cellname+"/Node:"+nodename+"/J2CResourceAdapter:" + rarname +"/"
		PrintHelper.printInfo("Updating stand alone adapter="+id+" on node="+nodename)
		raID = AdminConfig.getid(id)
		if raID == '':
			PrintHelper.printInfo( "cannot find RAR. Please provide valid RAR name.")
			return
			#sys.exit()

		if raID.find(lineSeparator)!=-1:
			newraarr = raID.split(lineSeparator)
			raID = newraarr[0]

		saveMCFprop(raID,dir,rarname)
		saveASprop(raID,dir,rarname)
		saveClasspath(raID,dir,rarname)
		removeRAR(raID,rarname)
		installRAR(cellname,nodename,rarname,rarpath)

		#Search for the properties files
		PrintHelper.printInfo("Recovering CF/AS for stand alone adapter="+id+" on node="+nodename)
		propertyFiles = WPSMigrationUtil.getAllFilesInFolder(dir, ".properties")
		for filename in propertyFiles:
			if(filename.find(rarname + "_RA_") == 0):
				raProperty = getPropertiesFromFile(dir + filename)
				createRAproperty(cellname,nodename,rarname,raProperty)
			else:
				if (filename.find(rarname+"_CF_") == 0):
					cfProperty = getPropertiesFromFile(dir + filename)
					createConnectionFactory(cellname,nodename,rarname,cfProperty)
				else:
					if(filename.find(rarname+"_AS_") == 0):
						asProperty = getPropertiesFromFile(dir + filename)
						createActivationSpec(cellname,nodename,rarname,asProperty,dir)
	except:
		PrintHelper.printInfo('updateStandAloneRAR for adapter='+rarname+' on node='+nodename+' failed. root cause:')
		PrintHelper.printInfo(sys.exc_type)
		PrintHelper.printInfo(sys.exc_value)
	else:
		PrintHelper.printInfo("Done updating stand alone adapter="+id+" on node="+nodename)
		if ( WPSMigrationUtil.toRemoveTempFiles() ):
			WPSMigrationUtil.deleteFile(dir)
#end def updateStandAloneRAR