#BEGIN COPYRIGHT
#************************************************************************************
# IBM Confidential
# OCO Source Materials
# 5639-D57,5630-A36,5630-A37,5724-D18
# @ Copyright IBM Corporation 2010.
# The source code for this program is not published or otherwise
# divested of its trade secrets, irrespective of what has been
# deposited with the U.S. Copyright Office.
#*************************************************************************
#END COPYRIGHT

import sys
from com.ibm.j2ca.migration.wpsruntime.base import WPSMigrationUtil
from java.lang import System

# Retrieve the value of WPS HOME from system environment property
wpsRootPath=WPSMigrationUtil.getSystemProperty("was.install.root")
# Define the script path
fileSeparator=WPSMigrationUtil.getFileSeparator()
scriptsPath=wpsRootPath+fileSeparator+"util"+fileSeparator+"adapterMigration"+fileSeparator
sys.path.append(scriptsPath)

import printHelper as PrintHelper

# Set the environment property value: WPS_HOME
PrintHelper.printInfo("WPS_HOME = "+wpsRootPath)
WPSMigrationUtil.setWPSHome(wpsRootPath)
# Set the environment property value for new adapter RAR path
newRARFolder=wpsRootPath+fileSeparator+"installableApps"+fileSeparator
WPSMigrationUtil.setNewRARDir(newRARFolder)
# Set the environment property value for migration temp folder
tempFolder=WPSMigrationUtil.getSystemProperty("bpm.upgrade.backup.dir")
WPSMigrationUtil.setTempDir(tempFolder)
lineSeparator = System.getProperty("line.separator")

import findEmbeddedRAApplications as FindEmbededRAApps
import findStandaloneRAApplications as FindStandAloneRAApps
import updateEmbededRAR as UpdateEmbededRAR
import updateStandaloneRAR as UpdateStandAloneRAR
import migrateApp as MigrateApp

#-------------------------------------------------------------------------------------------
#  Sub modules for embeded adapters/applications migration
#-------------------------------------------------------------------------------------------
def migrateEmbededRAApps(configurationFile):
	embededRAApps = FindEmbededRAApps.findEmbeddedRAApps()
	PrintHelper.printInfo(embededRAApps)
	#PrintHelper.printInfo("Start embeded adapter/application migration...")

	for app in embededRAApps[:]:
		appName=app[0]
		connectorModules=app[1]
		PrintHelper.printInfo(connectorModules)
		for connector in connectorModules[:]:
			adapterName=connector[0]
			adapterVersion=connector[1]
			adapterURI=connector[2]
			adapterID=connector[3]

			if ( WPSMigrationUtil.isSupportedArtifact(adapterName, adapterVersion)):
				# Export the application to ear file under the migration working directory
				migrationWorkDir = WPSMigrationUtil.getMigrationWorkDir()
				try:
					PrintHelper.printInfo("----Embedded application to be migrated = "+appName)
					exportEarFile = migrationWorkDir+appName+".ear"
					AdminApp.export(appName, exportEarFile)
					PrintHelper.printInfo("----Export app "+appName+" to file: "+exportEarFile)

					UpdateEmbededRAR.updateEmbededRAR(exportEarFile, appName, adapterName, adapterVersion, adapterURI, adapterID)
					MigrateApp.migrateApp(exportEarFile, appName, configurationFile)
					
					#asMLTList = AdminTask.listMessageListenerTypes(adapterID)
					#asMLTarr = asMLTList.split(lineSeparator)

					#for activationspecMessageType in asMLTarr:
						#if (activationspecMessageType != ''):
							#activationspeclist = AdminTask.listJ2CActivationSpecs(adapterID,"[-messageListenerType " + activationspecMessageType +" ]")
							#activationspecarr = activationspeclist.split(lineSeparator)
							#for activationspec in activationspecarr:
								#if (activationspec != ''):
									#authAlias=AdminConfig.showAttribute(activationspec,'authenticationAlias')
									#if(authAlias != None and authAlias.find("/")!=-1):
										#oldNodename = authAlias.split("/")[0]
										#newNodename = MigrateApp.getNodename()
										#AdminConfig.resetAttributes(activationspec,[['authenticationAlias',authAlias.replace(oldNodename,newNodename)]])
										#AdminConfig.save()
					
#					cfInterface = AdminTask.listConnectionFactoryInterfaces(adapterID)
#					cflist = AdminTask.listJ2CConnectionFactories(adapterID,"[-connectionFactoryInterface " + cfInterface + "]")
#					cfarr = cflist.split(lineSeparator)

#					for mcf in cfarr:
#						if(mcf != ''):
#							print 'mcf:'+mcf
#							authDataAlias=AdminConfig.showAttribute(mcf,'authDataAlias')
#							if(authDataAlias != None and authDataAlias.find("/")!=-1):
#								oldNodename = authDataAlias.split("/")[0]
#								newNodename = MigrateApp.getNodename()
#								AdminConfig.resetAttributes(mcf,[['authDataAlias',authDataAlias.replace(oldNodename,newNodename)]])
#								AdminConfig.save()
					
					PrintHelper.printInfo("----Embedded application migration Done for app = "+appName)
				except:
					PrintHelper.printInfo("----FAIL: Embedded application migration failed for app = "+appName)
					PrintHelper.printInfo('root cause: '+ sys.exc_type + sys.exc_value)
				# Delete the Work Dir
				if ( WPSMigrationUtil.toRemoveTempFiles() ):
					WPSMigrationUtil.deleteFile(migrationWorkDir)
		#endFor
	#endFor
#end def migrateEmbededRAApps

#-------------------------------------------------------------------------------------------
#  Sub modules for standalone adapters/applications migration
#-------------------------------------------------------------------------------------------
def migrateStandAloneRAApps(configurationFile, nodeName):
	raStandaloneRAAppList = FindStandAloneRAApps.findStandaloneRAApps(nodeName)

	for oneNode in raStandaloneRAAppList:
		toMigrateApps = []
		node = oneNode[0]
		PrintHelper.printInfo(node)
		adapters = oneNode[1]
		PrintHelper.printInfo(adapters)
		for oneAdapter in adapters:
			PrintHelper.printInfo(oneAdapter)
			ra = oneAdapter[0]
			raN = oneAdapter[1]
			raV = oneAdapter[2]
			PrintHelper.printInfo(ra)
			if ( WPSMigrationUtil.isSupportedArtifact(raN, raV)):
				nodename = node.split('(')[0]
				#UpdateStandAloneRAR.updateStandAloneRAR(nodename, raN)

				CFs = oneAdapter[3]
				PrintHelper.printInfo(CFs)
				for oneCF in CFs:
					cfJNDI = oneCF[0]
					PrintHelper.printInfo(cfJNDI)
					apps_CF = oneCF[1]
					PrintHelper.printInfo(apps_CF)
					for oneApp_CF in apps_CF :
						appNames_CF = FindStandAloneRAApps.wsadminToList(oneApp_CF)
						for appName in appNames_CF:
							if ( appName not in toMigrateApps):
								toMigrateApps.append(appName)
					#endfor
				#endfor

				ASs = oneAdapter[4]
				PrintHelper.printInfo(ASs)
				for oneAS in ASs:
					asJNDI = oneAS[0]
					PrintHelper.printInfo(asJNDI)
					apps_AS = oneAS[1]
					PrintHelper.printInfo(apps_AS)
					for oneApp_AS in apps_AS :
						appNames_AS = FindStandAloneRAApps.wsadminToList(oneApp_AS)
						for appName in appNames_AS:
							if ( appName not in toMigrateApps):
								toMigrateApps.append(appName)
					#endfor
				#endfor
			#end if
		#endfor RA
		
		for appName in toMigrateApps:
			MigrateApp.migrateStandaloneApp(appName, configurationFile)
			PrintHelper.printInfo("----Application "+appName+" on node="+nodeName+" is migrated")

	#endfor
#end def migrateStandAloneRAApps

def migrateClusterApps(configurationFile):
	#--------------------------------------------------------------
	# Will check the applications that reference to the adapter MCF/AS defined on clusters
	#--------------------------------------------------------------    
	clusterApps = FindStandAloneRAApps.findClusterApps()
	
	for oneCluster in clusterApps:
		toMigrateApps = []
		cluster = oneCluster[0]
		clusterRA_AppsList = oneCluster[1]
		for oneClusterRA in clusterRA_AppsList:
			clusterRA = oneClusterRA[0]
			clusterRAName = oneClusterRA[1]
			clusterRAVersion = oneClusterRA[2]
			if ( WPSMigrationUtil.isSupportedArtifact(clusterRAName, clusterRAVersion)):
				clusterRA_CFApps = oneClusterRA[3]
				for oneCF in clusterRA_CFApps:
					cfJNDI = oneCF[0]
					apps_CF = oneCF[1]
					for oneApp_CF in apps_CF :
						appNames_CF = FindStandAloneRAApps.wsadminToList(oneApp_CF)
						for appName in appNames_CF:
							if ( appName not in toMigrateApps):
								toMigrateApps.append(appName)
					#endfor
				#endfor
				
				clusterRA_ASApps = oneClusterRA[4]
				for oneAS in clusterRA_ASApps:
					asJNDI = oneAS[0]
					apps_AS = oneAS[1]
					for oneApp_AS in apps_AS :
						appNames_AS = FindStandAloneRAApps.wsadminToList(oneApp_AS)
						for appName in appNames_AS:
							if ( appName not in toMigrateApps):
								toMigrateApps.append(appName)
					#endfor
				#endfor
			#end if
		#end for -- RA

		for appName in toMigrateApps:
			MigrateApp.migrateStandaloneApp(appName, configurationFile)
			PrintHelper.printInfo("----Application "+appName+" on cluster is migrated")
		
	#endFor -- cluster
#end

def getNodeType():
	nodeType = WPSMigrationUtil.getSystemProperty("bpm.upgrade.node.type")
	if (nodeType==""):
		nodelist = AdminConfig.list('Node')
		nodeArr = FindStandAloneRAApps.wsadminToList(nodelist)
		nodeNum = len(nodeArr)
		if ( nodeNum > 1 ):
			nodeType = "dmgr"
		else:
			nodeType = "node"
	
	return nodeType
#end def getNodeType

def getClusterName():
	clusterName = WPSMigrationUtil.getSystemProperty("bpm.upgrade.cluster.name")
	return clusterName
# end def getClusterName

#-------------------------------------------------------------------------------------------
#  Main program
#-------------------------------------------------------------------------------------------
if __name__ == "__main__":
	PrintHelper.printInfo("********************************************************")
	PrintHelper.printInfo("********************************************************")
	configurationFile = scriptsPath+"adapterMigrationInfo.xml"
	PrintHelper.printInfo("----Loading configuration info from "+configurationFile)
	WPSMigrationUtil.getAdapterMigrationInfo(configurationFile)
	
	#if ( WPSMigrationUtil.getCustomProperty("skipAdapterMigration").lower() == "true" ):
	#	PrintHelper.printInfo("----Skip adapter migration...")
	#	return
	
	tempFolder = WPSMigrationUtil.getTempDir();
	PrintHelper.printInfo("Temp Folder = "+tempFolder)

	nodeType = getNodeType()
	if ( nodeType=="dmgr" ):
		if ( '' == getClusterName() ):
			PrintHelper.printInfo("---DMGR migration....")
		else:
			PrintHelper.printInfo("---Cluster migration.... Cluster="+getClusterName())
	else:
		PrintHelper.printInfo("---Node profile migration.... Node="+MigrateApp.getNodename())

	# migrate embeded adapters and applications
	PrintHelper.printInfo("----Migrating embeded adapters and applications...")
	migrateEmbededRAApps(configurationFile)
	PrintHelper.printInfo("----Done embeded adapters and applications migration\n")

	#migrate stand-alone adapters and applications
	if ( nodeType=="dmgr" ):
		PrintHelper.printInfo("----Migrating applications on DMGR/Cluster...")
		migrateClusterApps(configurationFile)
		PrintHelper.printInfo("----Done applications migration on DMGR/Cluster...")
	else:
		nodeName = MigrateApp.getNodename();
		PrintHelper.printInfo("----Migrating standalone adapters and applications on node="+nodeName+"...")
		migrateStandAloneRAApps(configurationFile, nodeName)
		PrintHelper.printInfo("----Done standalone adapters and applications migration on node="+nodeName+"...\n")

	PrintHelper.printInfo("----Profile migration done")
#end of main program